aglsetup: generate setup manifest file
[AGL/meta-agl.git] / scripts / .aglsetup_genconfig.bash
1 #!/bin/bash
2
3 ################################################################################
4 #
5 # The MIT License (MIT)
6 #
7 # Copyright (c) 2016 Stéphane Desneux <sdx@iot.bzh>
8 #           (c) 2016 Jan-Simon Möller <jsmoeller@linuxfoundation.org>
9 #
10 # Permission is hereby granted, free of charge, to any person obtaining a copy
11 # of this software and associated documentation files (the "Software"), to deal
12 # in the Software without restriction, including without limitation the rights
13 # to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
14 # copies of the Software, and to permit persons to whom the Software is
15 # furnished to do so, subject to the following conditions:
16 #
17 # The above copyright notice and this permission notice shall be included in
18 # all copies or substantial portions of the Software.
19 #
20 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
21 # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
22 # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
23 # AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
24 # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
25 # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
26 # SOFTWARE.
27 #
28 ################################################################################
29
30 # this script shouldn't be called directly, but through aglsetup.sh that will in
31 # turn execute (source) generated instructions back in the parent shell,
32 # whether it's bash, zsh, or any other supported shell
33
34 VERSION=1.1.0
35 DEFAULT_MACHINE=qemux86-64
36 DEFAULT_BUILDDIR=./build
37 VERBOSE=0
38 DEBUG=0
39
40 #SCRIPT=$(basename $BASH_SOURCE)
41 SCRIPT=aglsetup.sh
42 SCRIPTDIR=$(cd $(dirname $BASH_SOURCE) && pwd -P)
43 METADIR=$(cd $(dirname $BASH_SOURCE)/../.. && pwd -P)
44
45 function info() { echo "$@" >&2; }
46 function infon() { echo -n "$@" >&2; }
47 function error() { echo "ERROR: $@" >&2; return 1; }
48 function verbose() { [[ $VERBOSE == 1 ]] && echo "$@" >&2; return 0; }
49 function debug() { [[ $DEBUG == 1 ]] && echo "DEBUG: $@" >&2; return 0;}
50
51 info "------------ $SCRIPT: Starting"
52
53 #compute AGL_REPOSITORIES
54 AGL_REPOSITORIES=$(for x in $(ls -d $METADIR/*/templates/{machine,feature}); do echo $(basename $(dirname $(dirname $x))); done | sort -u)
55
56 function list_machines() {
57         for x in $@; do
58                 for y in $(ls -d $METADIR/$x/templates/machine/* 2>/dev/null); do
59                         echo $(basename $y)
60                 done
61         done
62 }
63
64 function list_all_machines() {
65         for x in $AGL_REPOSITORIES; do
66                 list_machines $x
67         done
68 }
69
70 function validate_builddir() {
71         if [[ "$BUILDDIR" =~ [[:space:]] ]]; then
72                 error "Build dir '$BUILDDIR' shouldn't contain any space"
73         fi
74         debug "Build dir is valid"
75 }
76
77 function validate_machines() {
78         list_all_machines | sort | uniq -c | while read cnt machine; do
79                 [[ $cnt == 1 ]] && continue
80                 info "Machine $machine found in the following repositories:"
81                 for x in $(ls -d $METADIR/*/templates/machine/$machine); do
82                         info "   - $x"
83                 done
84                 error "Multiple machine templates are not allowed"
85         done
86         debug "Machines list has no duplicate."
87 }
88
89 function list_features() {
90         for x in $@; do
91                 for y in $(ls -d $METADIR/$x/templates/feature/* 2>/dev/null); do
92                         echo $(basename $y)
93                 done
94         done
95 }
96
97 function list_all_features() {
98         for x in $AGL_REPOSITORIES; do
99                 list_features $x
100         done
101 }
102
103 function validate_features() {
104         list_all_features | sort | uniq -c | while read cnt feature; do
105                 [[ $cnt == 1 ]] && continue;
106                 info "Feature $feature found in the following repositories:"
107                 for x in $(ls -d $METADIR/*/templates/feature/$feature); do
108                         info "   - $x"
109                 done
110                 error "Multiple feature templates are not allowed"
111         done
112         debug "Features list has no duplicate."
113 }
114
115 function find_machine_dir() {
116         machine=$1
117         for x in $AGL_REPOSITORIES; do
118                 dir=$METADIR/$x/templates/machine/$machine
119                 [[ -d $dir ]] && { echo $dir; return 0; }
120         done
121         return 1
122 }
123
124 function find_feature_dir() {
125         feature=$1
126         for x in $AGL_REPOSITORIES; do
127                 dir=$METADIR/$x/templates/feature/$feature
128                 [[ -d $dir ]] && { echo $dir; return 0; }
129         done
130         return 1
131 }
132
133 function usage() {
134     cat <<EOF >&2
135 Usage: . $SCRIPT [options] [feature [feature [... ]]]
136
137 Version: $VERSION
138 Compatibility: bash, zsh, ksh
139
140 Options:
141    -m|--machine <machine>
142       what machine to use
143       default: '$DEFAULT_MACHINE'
144    -b|--build <directory>
145       build directory to use
146       default: '$DEFAULT_BUILDDIR'
147    -s|--script <filename>
148       file where setup script is generated
149       default: none (no script)
150    -f|--force
151       flag to force overwriting any existing configuration
152       default: false
153    -r|--rpm-revision <schema>
154       Specify how to handle RPM packages revisions
155       <schema> can be:
156           'prservice[:<address>]' : Use a PR service daemon.
157               if <address> is not specified, the default value 'localhost:0'
158               is used (shortcut for a PR service started by bitbake)
159           'timestamp' : Use a generated time stamp (UTC).
160           'value:<revision>' : Use <revision> explicitly.
161           'none' : Do nothing.
162    -v|--verbose
163       verbose mode
164       default: false
165    -d|--debug
166       debug mode
167       default: false
168    -h|--help
169       get some help
170
171 EOF
172         local buf
173
174         echo "Available machines:" >&2
175         for x in $AGL_REPOSITORIES; do
176                 buf=$(list_machines $x)
177                 [[ -z "$buf" ]] && continue
178                 echo "   [$x]"
179                 for y in $buf; do
180                         [[ $y == $DEFAULT_MACHINE ]] && def="* " || def="  "
181                         echo "     $def$y"
182                 done
183         done
184         echo >&2
185
186         echo "Available features:" >&2
187         for x in $AGL_REPOSITORIES; do
188                 buf=$(list_features $x)
189                 [[ -z "$buf" ]] && continue
190                 echo "   [$x]"
191                 for feature in $buf; do
192                         print_feature="$feature"
193                         featuredir=$(find_feature_dir $feature)
194                         if [ -e $featuredir/included.dep ];then
195                                 print_feature="$print_feature :($(find_feature_dependency $feature $feature))"
196                         fi;
197                         echo "       $print_feature"
198                 done
199         done
200         echo >&2
201 }
202
203 function append_fragment() {
204         basefile=$1; shift # output file
205         f=$1; shift # input file
206         label=$(echo "$@")
207
208         debug "adding fragment to $basefile: $f"
209         echo >>$basefile
210         echo "# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #" >>$basefile
211         echo "# fragment { " >>$basefile
212         [[ -f $f ]] && echo "# $f" >>$basefile || true
213         echo "#" >>$basefile
214         [[ -n "$label" ]] && echo "$label" >>$basefile
215         [[ -f $f ]] && cat $f >>$basefile || true
216         echo "#" >>$basefile
217         echo "# }" >>$basefile
218         echo "# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #" >>$basefile
219         [[ -f $f ]] && echo $f >>$BUILDDIR/conf/fragments.log || true
220 }
221
222 function execute_setup() {
223         script=$1
224         debug "Executing script $script"
225         opts="-e"
226         [[ $DEBUG == 1 ]] && opts="$opts -x"
227         pushd $BUILDDIR &>/dev/null
228                 $BASH $opts $script \
229                         && rc=0 \
230                         || { rc=$?; error "Script $script failed"; }
231         popd &>/dev/null
232         return $rc
233 }
234
235
236 # process all fragments
237 FRAGMENTS_BBLAYERS=""
238 FRAGMENTS_LOCALCONF=""
239 FRAGMENTS_SETUP=""
240 function process_fragments() {
241         for dir in "$@"; do
242                 debug "processing fragments in dir $dir"
243
244                 verbose "   Searching fragments: $dir"
245
246                 # lookup for files with priorities specified: something like xx_bblayers.conf.yyyyy.inc
247                 for x in $(ls $dir/??[._]bblayers.conf*.inc 2>/dev/null); do
248                         FRAGMENTS_BBLAYERS="$FRAGMENTS_BBLAYERS $(basename $x):$x"
249                         verbose "      priority $(basename $x | cut -c1-2): $(basename $x)"
250                 done
251
252                 # same for local.conf
253                 for x in $(ls $dir/??[._]local.conf*.inc 2>/dev/null); do
254                         FRAGMENTS_LOCALCONF="$FRAGMENTS_LOCALCONF $(basename $x):$x"
255                         verbose "      priority $(basename $x | cut -c1-2): $(basename $x)"
256                 done
257
258                 # same fot setup.sh
259                 for x in $(ls $dir/??[._]setup*.sh 2>/dev/null); do
260                         FRAGMENTS_SETUP="$FRAGMENTS_SETUP $(basename $x):$x"
261                         verbose "      priority $(basename $x | cut -c1-2): $(basename $x)"
262                 done
263         done
264 }
265
266 function containsFeature () {
267   for feature in $1; do
268     [[ "$feature" == "$2" ]] && return 1;
269   done;
270   return 0;
271 }
272
273 function find_feature_dependency() {
274         res_dep_features=""
275         featuredir=$(find_feature_dir $1)
276         full_feature=$2;
277         if [ -e $featuredir/included.dep ]; then
278                 dep_features="$(cat $featuredir/included.dep)"
279                 for dep_feature in $dep_features; do
280                         full_feature="$full_feature $res_dep_features"
281                         res_dep_features="$res_dep_features $dep_feature"
282                         if  containsFeature $dep_feature $full_feature ; then
283                                 res_dep_features="$res_dep_features $(find_feature_dependency $dep_feature $full_feature)"
284                         fi;
285                 done;
286         fi;
287         echo "$res_dep_features";
288         return 0;
289 }
290
291 GLOBAL_ARGS=( "$@" )
292 debug "Parsing arguments: $@"
293 TEMP=$(getopt -o m:b:r:s:fvdh --long machine:,builddir:,rpm-revision:,script:,force,verbose,debug,help -n $SCRIPT -- "$@")
294 [[ $? != 0 ]] && { usage; exit 1; }
295 eval set -- "$TEMP"
296
297 set -e
298
299 ### default options values
300 MACHINE=$DEFAULT_MACHINE
301 BUILDDIR=$DEFAULT_BUILDDIR
302 SETUPSCRIPT=
303 FORCE=
304 RPMREVISION=
305 while true; do
306         case "$1" in
307                 -m|--machine)      MACHINE=$2; shift 2;;
308                 -b|--builddir)     BUILDDIR=$2; shift 2;;
309                 -s|--setupscript)  SETUPSCRIPT=$2; shift 2;;
310                 -f|--force)        FORCE=1; shift;;
311                 -r|--rpm-revision) RPMREVISION=$2; shift 2;;
312                 -v|--verbose)      VERBOSE=1; shift;;
313                 -d|--debug)        VERBOSE=1; DEBUG=1; shift;;
314                 -h|--help)         HELP=1; shift;;
315                 --)                shift; break;;
316                 *) error "Arguments parsing error"; exit 1;;
317         esac
318 done
319
320 [[ "$HELP" == 1 ]] && { usage; exit 0; }
321
322 verbose "Command line arguments: ${GLOBAL_ARGS[@]}"
323
324 # the remaining args are the features
325 FEATURES="$@"
326
327 # validate the machine list
328 debug "validating machines list"
329 validate_machines
330
331 # validate the machine
332 debug "validating machine $MACHINE"
333 find_machine_dir $MACHINE >/dev/null || error "Machine '$MACHINE' not found in [ $(list_all_machines)]"
334
335 # validate the features list
336 debug "validating features list"
337 validate_features
338
339 TMP_FEATURES="";
340 for FEATURE in $FEATURES;do
341     TMP_FEATURES="$TMP_FEATURES $FEATURE"
342     TMP_FEATURES="$TMP_FEATURES $(find_feature_dependency $FEATURE $TMP_FEATURES)"
343 done
344 # remove duplicate features if any
345 FEATURES=$(for x in $TMP_FEATURES; do echo $x; done | sort -u | awk '{printf("%s ",$1);}')
346
347 # validate the features
348 for f in $FEATURES; do
349         debug "validating feature $f"
350         find_feature_dir $f >/dev/null || error "Feature '$f' not found in [ $(list_all_features)]"
351 done
352
353 # validate build dir
354 debug "validating builddir $BUILDDIR"
355 BUILDDIR=$(mkdir -p "$BUILDDIR" && cd "$BUILDDIR" && pwd -P)
356 validate_builddir
357
358 ###########################################################################################
359 function dump_log() {
360         info "    ------------ $(basename $1) -----------------"
361         sed 's/^/   | /g' $1
362         info "    ----------------------------------------"
363 }
364
365 function genconfig() {
366         info "Generating configuration files:"
367         info "   Build dir: $BUILDDIR"
368         info "   Machine: $MACHINE"
369         info "   Features: $FEATURES"
370
371         # step 1: run usual OE setup to generate conf dir
372         export TEMPLATECONF=$(cd $SCRIPTDIR/../templates/base && pwd -P)
373         debug "running oe-init-build-env with TEMPLATECONF=$TEMPLATECONF"
374         info "   Running $METADIR/poky/oe-init-build-env"
375         info "   Templates dir: $TEMPLATECONF"
376
377         CURDIR=$(pwd -P)
378         . $METADIR/poky/oe-init-build-env $BUILDDIR >/dev/null
379         cd $CURDIR
380
381         # step 2: concatenate other remaining fragments coming from base
382         process_fragments $TEMPLATECONF
383
384         # step 3: fragments for machine
385         process_fragments $(find_machine_dir $MACHINE)
386
387         # step 4: fragments for features
388         for feature in $FEATURES; do
389                 process_fragments $(find_feature_dir $feature)
390         done
391
392         # step 5: sort fragments and append them in destination files
393         FRAGMENTS_BBLAYERS=$(sed 's/ /\n/g' <<<$FRAGMENTS_BBLAYERS | sort)
394         debug "bblayer fragments: $FRAGMENTS_BBLAYERS"
395         info "   Config: $BUILDDIR/conf/bblayers.conf"
396         for x in $FRAGMENTS_BBLAYERS; do
397                 file=${x/#*:/}
398                 append_fragment $BUILDDIR/conf/bblayers.conf $file
399                 verbose "      + $file"
400         done
401
402         FRAGMENTS_LOCALCONF=$(sed 's/ /\n/g' <<<$FRAGMENTS_LOCALCONF | sort)
403         debug "localconf fragments: $FRAGMENTS_LOCALCONF"
404         info "   Config: $BUILDDIR/conf/local.conf"
405         for x in $FRAGMENTS_LOCALCONF; do
406                 file=${x/#*:/}
407                 append_fragment $BUILDDIR/conf/local.conf $file
408                 verbose "      + $file"
409         done
410
411         FRAGMENTS_SETUP=$(sed 's/ /\n/g' <<<$FRAGMENTS_SETUP | sort)
412         debug "setup fragments: $FRAGMENTS_SETUP"
413         cat <<EOF >$BUILDDIR/conf/setup.sh
414 #!/bin/bash
415
416 # this script has been generated by $BASH_SOURCE
417
418 export MACHINE="$MACHINE"
419 export FEATURES="$FEATURES"
420 export BUILDDIR="$BUILDDIR"
421 export METADIR="$METADIR"
422 export RPMREVISION="$RPMREVISION"
423 export LOCALCONF="$BUILDDIR/conf/local.conf"
424
425 echo "--- beginning of setup script"
426 EOF
427         info "   Setup script: $BUILDDIR/conf/setup.sh"
428         for x in $FRAGMENTS_SETUP; do
429                 file=${x/#*:/}
430                 append_fragment $BUILDDIR/conf/setup.sh $file "echo '--- fragment $file'"
431                 verbose "      + $file"
432         done
433         append_fragment $BUILDDIR/conf/setup.sh "" "echo '--- end of setup script'"
434
435         infon "   Executing setup script ... "
436         execute_setup $BUILDDIR/conf/setup.sh 2>&1 | tee $BUILDDIR/conf/setup.log
437         [[ ${PIPESTATUS[0]} == 0 ]] && {
438                 info "OK"
439                 [[ $VERBOSE == 1 ]] && dump_log $BUILDDIR/conf/setup.log
440                 rm $BUILDDIR/conf/setup.sh
441         } \
442         || {
443                 info "FAIL: please check $BUILDDIR/conf/setup.log"
444                 dump_log $BUILDDIR/conf/setup.log
445                 return 1
446         }
447 }
448
449 ###########################################################################################
450
451 # check for overwrite
452 [[ $FORCE -eq 1 ]] && rm -f \
453         $BUILDDIR/conf/local.conf \
454         $BUILDDIR/conf/bblayers.conf \
455         $BUILDDIR/conf/setup.* \
456         $BUILDDIR/conf/*.log
457
458 ####### step 1: generate configuration file #######
459
460 if [[ -f $BUILDDIR/conf/local.conf || -f $BUILDDIR/conf/bblayers.conf ]]; then
461         info "Configuration files already exist:"
462         for x in $BUILDDIR/conf/local.conf $BUILDDIR/conf/bblayers.conf; do
463                 [[ -f $x ]] && info "   - $x"
464         done
465         info "Skipping configuration files generation."
466         info "Use option -f|--force to overwrite existing configuration."
467 else
468         genconfig
469 fi
470
471 ####### step 2: generate aglsetup.manifest #######
472
473 SETUP_MANIFEST=aglsetup.manifest
474
475 infon "Generating setup manifest: $BUILDDIR/$SETUP_MANIFEST ... "
476 for x in /etc/os-release /usr/lib/os-release; do
477         [[ -f $x ]] && . $x
478 done
479 FEATURES_md5=$(echo $FEATURES|md5sum -|awk '{print $1;}')
480 cat <<EOF >$BUILDDIR/$SETUP_MANIFEST
481 # ----------------------------------------------
482 # This fragment has been generated by $SCRIPT at setup time
483
484 # distro name
485 DIST_DISTRO_NAME="AGL"
486
487 # target machine as passed to $SCRIPT
488 DIST_MACHINE="$MACHINE"
489
490 # features as resolved by $SCRIPT
491 DIST_FEATURES="$FEATURES"
492 DIST_FEATURES_MD5="${FEATURES_md5}"
493
494 # build host information deduced from os-release
495 DIST_BUILD_HOST="$(id -un)@$(hostname -f || hostname || hostname -s)"
496 DIST_BUILD_OS="${PRETTY_NAME:-${NAME} ${VERSION} [COMPUTED]}"
497
498 # meta directory
499 DIST_METADIR="$METADIR"
500
501 # timestamp
502 DIST_SETUP_TS="$(date -u +%Y%m%d_%H%M%S_%Z)"
503
504 # ------------ end of $SCRIPT fragment --------
505 EOF
506 info "OK"
507
508 ####### step 3: generate agl-init-build-env #######
509
510 # always generate setup script in builddir: it can be sourced later manually without re-running the setup
511 infon "Generating setup file: $BUILDDIR/agl-init-build-env ... "
512
513 cat <<EOF >$BUILDDIR/agl-init-build-env
514 . $METADIR/poky/oe-init-build-env $BUILDDIR
515 if [ -n "\$DL_DIR" ]; then
516         BB_ENV_EXTRAWHITE="\$BB_ENV_EXTRAWHITE DL_DIR"
517 fi
518 if [ -n "\$SSTATE_DIR" ]; then
519         BB_ENV_EXTRAWHITE="\$BB_ENV_EXTRAWHITE SSTATE_DIR"
520 fi
521
522 # build manifest generator used in distro-build-manifest.bb
523 BB_ENV_EXTRAWHITE="\$BB_ENV_EXTRAWHITE DISTRO_SETUP_MANIFEST DISTRO_MANIFEST_GENERATOR"
524 export DISTRO_SETUP_MANIFEST=$(realpath -Ls $BUILDDIR)/$SETUP_MANIFEST
525 export DISTRO_MANIFEST_GENERATOR=$(dirname $(realpath $BASH_SOURCE))/distro-manifest-generator.sh
526
527 export BB_ENV_EXTRAWHITE
528 unset TEMPLATECONF
529 EOF
530 info "OK"
531
532 ####### step 4: generate output script #######
533
534 # finally, generate output script if requested by caller
535 if [[ -n "$SETUPSCRIPT" ]]; then
536         debug "generating setupscript in $SETUPSCRIPT"
537         cat <<EOF >$SETUPSCRIPT
538 . $BUILDDIR/agl-init-build-env
539 EOF
540 fi
541
542 info "------------ $SCRIPT: Done"